#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <pthread.h>

pthread_mutex_t resource[5];
char res_str[] = "00000";

int pick(){return rand()%5;}
int pick2(){return rand()%2+1;}

void* t1 (void * p) {
  int r1, r2;
  while(1) {                    //Undvik att tråden försöker låsa en resurs två gånger.
    r1=pick(); r2=pick();
    while(r1==r2)
    {
        r2=pick();
    }
    sleep(pick2());
    pthread_mutex_lock(&resource[r1]);
    res_str[r1]='1';
    pthread_mutex_lock(&resource[r2]);
    res_str[r2]='1';
    sleep(pick2());
    res_str[r1]='0';
    res_str[r2]='0';
    pthread_mutex_unlock(&resource[r1]);
    pthread_mutex_unlock(&resource[r2]);
  }
}

void* t2 (void * p) {
  int r1, r2;
  while(1) {                    //Undvik att tråden försöker låsa en resurs två gånger.
    r1=pick(); r2=pick();
    while(r1==r2)
    {
        r2=pick();
    }
    sleep(pick2());
    pthread_mutex_lock(&resource[r1]);
    res_str[r1]='2';
     while(pthread_mutex_trylock(&resource[r2]))        //Är r2 låst? Om JA: lås upp r1 och kör en sleep så att tråd t1 kan fortsätta
    {
        pthread_mutex_unlock(&resource[r1]);
        sleep(pick2());
        pthread_mutex_lock(&resource[r1]);

    }

    res_str[r2]='2';
    sleep(pick2());
    res_str[r1]='0';
    res_str[r2]='0';
    pthread_mutex_unlock(&resource[r1]);
    pthread_mutex_unlock(&resource[r2]);
  }
}

main() {
  int i=0,n;
  pthread_t id1, id2;
  pthread_create(&id1,NULL,&t1,NULL);
  pthread_create(&id2,NULL,&t2,NULL);
  while(i++<100)
  {
    sleep(1);
    printf("%2d: %s\n", i, res_str);
  }
}



